<?php
################################################################################
# @Name : ./forgot_pwd.php 
# @Description : send mail to user to init password
# @Call : /login.php
# @Author : Flox
# @Version : 3.1.50
# @Create : 25/10/2019
# @Update : 04/12/2019 p1
################################################################################

//init
require_once("core/init_get.php");
require('localization.php');

//initialize variable
if(!isset($error)) $error = '';
if(!isset($success)) $success = '';

if(!isset($_POST['mail'])) $_POST['mail'] = '';
if(!isset($_POST['password'])) $_POST['password'] = '';
if(!isset($_POST['password2'])) $_POST['password2'] = '';

$hide_form=0;

//secure string
$_POST['mail']=strip_tags($_POST['mail']);

//connexion script with database parameters
require "connect.php";

//switch SQL MODE to allow empty values
$db->exec('SET sql_mode = ""');

//load parameters table
$qry = $db->prepare("SELECT * FROM `tparameters`");
$qry->execute();
$rparameters=$qry->fetch();
$qry->closeCursor();

if($rparameters['user_forgot_pwd'])
{
	//modify password
	if($_GET['token'])
	{
		//check token
		$qry=$db->prepare("SELECT `user_id` FROM `ttoken` WHERE token=:token AND action='forgot_pwd' AND user_id!='0'");
		$qry->execute(array('token' => $_GET['token']));
		$token=$qry->fetch();
		$qry->closeCursor();
		if(isset($token))
		{
			if(isset($_POST['submit']))
			{
				//check passwords
				if(!$_POST['password'] || !$_POST['password2']) {$error='Les champs mot de passe doivent être renseignés.';}
				if($_POST['password']!=$_POST['password2']) {$error='Les mots de passes ne sont pas identiques.';}
				if($rparameters['user_password_policy'] && $_POST['password'] && !$error)
				{
					if(strlen($_POST['password'])<$rparameters['user_password_policy_min_lenght'])
					{
						$error=T_('Le mot de passe doit faire').' '.$rparameters['user_password_policy_min_lenght'].' '.T_('caractères minimum');
					}elseif($rparameters['user_password_policy_special_char'] && !preg_match('/[^a-zA-Z\d]/', $_POST['password']))
					{
						$error=T_('Le mot de passe doit contenir un caractère spécial');
					}elseif($rparameters['user_password_policy_min_maj'] && (!preg_match('/[A-Z]/', $_POST['password']) || !preg_match('/[a-z]/', $_POST['password'])))
					{
						$error=T_('Le mot de passe doit posséder au moins une lettre majuscule et une minuscule');
					}
				}
				
				if(!$error && $token['user_id'])
				{
					//update password
					$hash=password_hash($_POST['password'], PASSWORD_DEFAULT);
					$last_pwd_chg=date('Y-m-d');
					$qry=$db->prepare("UPDATE `tusers` SET `password`=:password, `last_pwd_chg`=:last_pwd_chg WHERE `id`=:id");
					$qry->execute(array('password' => $hash, 'last_pwd_chg' => $last_pwd_chg, 'id' =>  $token['user_id']));
					
					//clean token
					$qry=$db->prepare("DELETE FROM `ttoken` WHERE user_id=:user_id AND action='forgot_pwd'");
					$qry->execute(array('user_id' => $token['user_id']));
					
					$success=T_("Votre mot de passe à été modifié avec succès, vous pouvez vous connecter à l'application");
				}
			}
		} else {
			$error=T_('Jeton invalide, contacter votre administrateur');
			$hide_form=1;
		}
	}elseif(isset($_POST['submit'])) //send mail init password
	{
	    if(!$_POST['mail']) {$error=T_('Merci de renseigner une adresse mail');} 
		elseif(!filter_var($_POST['mail'], FILTER_VALIDATE_EMAIL)) {$error=T_("L'adresse mail est incorrecte");}
		else {
			//check if mail exist on gestsup user
			$qry=$db->prepare("SELECT `id`,`mail` FROM `tusers` WHERE mail=:mail AND disable='0'");
			$qry->execute(array('mail' => $_POST['mail']));
			$user=$qry->fetch();
			$qry->closeCursor();
			if($user)
			{
				//check only one account have this mail	
				$qry=$db->prepare("SELECT COUNT(id) FROM `tusers` WHERE mail=:mail AND disable='0'");
				$qry->execute(array('mail' => $_POST['mail']));
				$mail_number=$qry->fetch();
				$qry->closeCursor();
				if($mail_number[0]==1)
				{
					//create token
					$token = bin2hex(openssl_random_pseudo_bytes(10));
					$qry=$db->prepare("INSERT INTO `ttoken` (`token`,`action`,`user_id`) VALUES (:token,'forgot_pwd',:user_id)");
					$qry->execute(array('token' => $token,'user_id' => $user['id']));
					
					//mail definition
					$from=$rparameters['mail_from_adr'];
					$to=$user['mail'];
					$object=T_('Ré-initialisation de votre mot de passe GestSup');
					$message = '
					'.T_('Bonjour,').' <br />
					<br />
					<br />
					'.T_('Vous avez fait une demande de ré-initialisation de votre mot de passe GestSup, merci de cliquer sur le lien ci-après pour définir un nouveau mot de passe').' :<br />
					<br />
					<a href="'.$rparameters['server_url'].'/forgot_pwd.php?token='.$token.'">'.$rparameters['server_url'].'/forgot_pwd.php?token='.$token.'</a>	<br />
					<br />
					'.T_('Cordialement').'.';
					require('./core/message.php');
					
					if($mail_send)
					{
						$success=T_('Vous aller recevoir un mail pour ré-initialiser votre mot de passe');
					} else {
						$error=T_("Émission de mail impossible, contacter votre administrateur.");
					}
				} else {
					$error=T_("Plusieurs comptes GestSup possède cette adresse mail, contacter votre administrateur.");
				}
			} else {
				$error=T_("Aucun compte GestSup ne possède cette adresse mail.");
			}
		}
	}
    
	//display page
    echo'
    <!DOCTYPE html>
    <html lang="fr">
	<head>
		<meta charset="UTF-8" />
		<title>GestSup | Gestion de Support</title>
		<link rel="shortcut icon" type="image/png" href="./images/favicon_ticket.png" />
		<meta name="description" content="gestsup" />
		<meta name="viewport" content="width=device-width, initial-scale=1.0" />
		<!-- basic styles -->
		<link href="./components/bootstrap/css/bootstrap.min.css" rel="stylesheet" />
		<link rel="stylesheet" href="./template/assets/css/font-awesome.min.css" />
		<!--[if IE 7]>
		  <link rel="stylesheet" href="./template/assets/css/font-awesome-ie7.min.css" />
		<![endif]-->
		<!-- page specific plugin styles -->
		<!-- fonts -->
		<link rel="stylesheet" href="./template/assets/css/ace-fonts.css" />
		<link rel="stylesheet" href="components/jquery-ui/jquery-ui.min.css" />
		<!-- ace styles -->
		<link rel="stylesheet" href="./template/assets/css/ace.min.css" />
		<link rel="stylesheet" href="./template/assets/css/ace-rtl.min.css" />
		<link rel="stylesheet" href="./template/assets/css/ace-skins.min.css" />
		
		<!--[if lte IE 8]>
		  <link rel="stylesheet" href="./template/assets/css/ace-ie.min.css" />
		<![endif]-->
		<!-- inline styles related to this page -->
		<!-- ace settings handler -->
		<script src="./template/assets/js/ace-extra.min.js"></script>
		<!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
		<!--[if lt IE 9]>
		<script src="./template/assets/js/html5shiv.js"></script>
		<script src="./template/assets/js/respond.min.js"></script>
		<![endif]-->
	</head>
		<body class="login-layout">
		<br />
		<br />
		<br />
		<div class="main-container">
			<div class="main-content">
				<div class="row">
					<div class="col-sm-10 col-sm-offset-1">
						<div class="login-container">
							<div class="center">
								<h1>
									<i class="icon-ticket green"></i>
									<span class="white">GestSup</span>
								</h1>
								<h4 class="blue">';if (isset($rparameters['company'])) echo $rparameters['company']; echo' </h4>
								';
								//re-size logo if height superior 40px
								if ($rparameters['logo']!='' && file_exists("./upload/logo/$rparameters[logo]")) 
								{
									$size = getimagesize("./upload/logo/$rparameters[logo]");
									$width=$size[0];
									if ($width>300) {$logo_width='width="300"';} else {$logo_width='';}
								} else {$logo_width=''; }
								//display logo if image file exist
								if (file_exists("./upload/logo/$rparameters[logo]"))
								{
									echo '<img style="border-style: none" alt="logo" '.$logo_width.' src="./upload/logo/'; if ($rparameters['logo']=='') echo 'logo.png'; else echo $rparameters['logo'];  echo '" />';
								}
								echo '
							</div>
							<br />
							';
							if($error) {echo '<div class="alert alert-danger"><button type="button" class="close" data-dismiss="alert"><i class="icon-remove"></i></button><strong><i class="icon-remove"></i> '.T_('Erreur').'</strong> : '.$error.'<br></div>';}
							if($success) {echo '<div class="alert alert-block alert-success"><center><i class="icon-ok green"></i> '.$success.'</center></div>';}
							
							if(!$hide_form)
							{
								//display forms
								echo '
								<div class="space-6"></div>
								<div class="position-relative">
									<div id="login-box" class="forgot-box widget-box no-border visible">
										<div class="widget-body">
											<div class="widget-main">
												<h4 class="header red lighter bigger">
													<i class="icon-key"></i>
													'.T_('Ré-initialisation mot de passe').'
												</h4>
												<div class="space-6"></div>
												';
												if($_GET['token'])
												{
													//display init password form
													echo '
													<p>'.T_('Entrez votre nouveau mot de passe').'</p>
													<form id="conn" method="post" action="">	
														<fieldset>
															<label class="block clearfix">
																<span class="block input-icon input-icon-right">
																	<input class="form-control span12" autocomplete="new-password" id="password" name="password" type="password" placeholder="'.T_('Mot de passe').'" value="'.$_POST['password'].'" />
																	<i class="icon-key"></i>
																</span>
															</label>
															<label class="block clearfix">
																<span class="block input-icon input-icon-right">
																	<input class="form-control span12" autocomplete="new-password" id="password2" name="password2" type="password" placeholder="'.T_('Confirmer mot de passe').'" value="'.$_POST['password2'].'" />
																	<i class="icon-key"></i>
																</span>
															</label>
															<div class="space"></div>
															<div class="clearfix">
																<button onclick="submit()" type="submit" id="submit" name="submit" class="width-35 pull-right btn btn-sm btn-danger">
																	<i class="icon-ok"></i>
																	'.T_('Valider').'
																</button>
															</div>
															<div class="space-4"></div>
														</fieldset>
													</form>
													';
													
												} else {
													//display mail form
													echo '
													<p>'.T_('Entrez votre adresse mail').'</p>
													<form id="conn" method="post" action="">	
														<fieldset>
															<label class="block clearfix">
																<span class="block input-icon input-icon-right">
																	<input class="form-control" type="text" id="mail" name="mail" class="span12" placeholder="'.T_('Adresse Mail').'" value="'.$_POST['mail'].'" />
																	<i class="icon-envelope"></i>
																</span>
															</label>
															<div class="space"></div>
															<div class="clearfix">
																<button onclick="submit()" type="submit" id="submit" name="submit" class="width-35 pull-right btn btn-sm btn-danger">
																	<i class="icon-ok"></i>
																	'.T_('Valider').'
																</button>
															</div>
															<div class="space-4"></div>
														</fieldset>
													</form>
													';
												}
												echo '
											</div><!--/widget-main-->
											<div class="toolbar">
												<div align="right">
													<a href="./"  class="back-to-login-link">
														'.T_('Retour').'
														<i class="icon-arrow-right"></i>
													</a>
												</div>
											</div>
										</div><!--/widget-body-->
									</div><!--/login-box-->
								</div><!--/position-relative-->
								';
							}
							echo '
						</div>
					</div><!--/.span-->
				</div><!--/.row-fluid-->
			</div>
			<span style="position: absolute; bottom: 0; right: 0;"><a href="https://gestsup.fr">GestSup.fr</a></span>
		</div><!--/.main-container-->
	';
		//close db access
		unset($db); 
        echo '
	</body>
</html>';
} else {
    echo '<span style="color:red;"> <b>'.T_('Erreur').' :</b> '.T_("La fonction de ré-initialisation des mots de passe est désactivée par votre administrateur").'.<span>';
}
?>